﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace MyTimer
{
    public partial class MyTimer : Form
    {
        const string ApplicationName = "MyTimer";
        const string Version = "ver. 0.2";
        private int sec = 0;
        private int hideWindowCount = 0;

        public MyTimer()
        {
            InitializeComponent();
        }

        private void resetProgressBar()
        {
            progressBar1.Maximum = 100;
            progressBar1.Value = 100;
            progressBar1.ForeColor = System.Drawing.SystemColors.Highlight;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            sec--;
            progressBar1.Value = sec;
            if ( sec == 0)
            {
                timer1.Enabled = false;
                MessageBox.Show("Time's Up!!", "info");
                resetProgressBar();
            }
            
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void start25minTimer()
        {
#if DEBUG
            sec = 5;
#else
            sec = 25 * 60;
#endif
            progressBar1.Maximum = sec;
            progressBar1.Value = sec;
            timer1.Enabled = true;
            this.WindowState = FormWindowState.Normal;
            this.progressBar1.ForeColor = System.Drawing.Color.Orange;

        }

        private void MenuItemStart25min_Click(object sender, EventArgs e)
        {
            start25minTimer();
        }

        private void start5minTimer()
        {
#if DEBUG
            sec = 5;
#else
            sec = 5 * 60;
#endif
            progressBar1.Maximum = sec;
            progressBar1.Value = sec;
            timer1.Enabled = true;
            this.WindowState = FormWindowState.Normal;
            this.progressBar1.ForeColor = System.Drawing.Color.Blue;
        }

        private void MenuItemStart5min_Click(object sender, EventArgs e)
        {
            start5minTimer();
        }

        private void MyTimer_MouseEnter(object sender, EventArgs e)
        {
            if( this.WindowState == FormWindowState.Normal)
            {
                this.Hide();
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            hideWindowCount--;
            if(hideWindowCount == 0)
            {
                System.Drawing.Point sp = System.Windows.Forms.Cursor.Position;
                System.Drawing.Point cp = this.PointToClient(sp);

                if( cp.X > 0 && cp.X < this.Width && cp.Y > 0 && cp.Y < this.Height){
                    hideWindowCount = 5;
                } else {
                    timer2.Enabled = false;
                    this.Show();
                }

            }

        }

        private void MyTimer_MouseLeave(object sender, EventArgs e)
        {
            hideWindowCount = 5; // 500msec
            timer2.Enabled = true;
        }

        private void MenuItemVersion_Click(object sender, EventArgs e)
        {
            MessageBox.Show(ApplicationName + " " + Version + Environment.NewLine + "(C)2016 mffukui", "Version");
        }

         private void MyTimer_Load(object sender, EventArgs e)
        {
            resetProgressBar();
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.F2)
            {
                start25minTimer();
                return false;
            } else if(keyData == Keys.F5)
            {
                start5minTimer();
                return false;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
    }
}
